


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    set RegName "*"
    set RegN ""
    set RegData 0

    variable NetVarList [list NULL]

    set RegT int
    set RegP rw
    set RegF x
    set RegA 0
    set RegI 0
    set RegL 1

    set tList [list int uint long ulong short ushort char uchar string float double]
    set pList [list rw ro]
    set fList [list x d]
    set aList [list 0 1]

    proc show_variables {} {
        variable LogFlag
        variable LogCount
        variable ShowLogFlag

       variable RegName 
       variable RegN
       variable RegT
       variable RegP 
       variable RegF
       variable RegA
       variable RegData

         InsertLog "LogFlag=$LogFlag; LogCount=$LogCount; ShowLogFlag=$ShowLogFlag"
         InsertLog "RegName=$RegName; RegN=$RegN; RegT=$RegT; RegP=$RegP; RegF=$RegF; RegA=$RegA; RegData=$RegData"
    }

   proc do_create {} {
       variable RegName
       variable RegN
       variable RegT 
       variable RegP 
       variable RegF 
       variable RegA 
       variable RegI
       variable RegL
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:NetVarService \
            DefineRegister  $RegName NetVar "-n $RegN -t $RegT -p $RegP -f $RegF -a $RegA -l $RegL"} msg]

       if {$z == 0} {
           InsertLog "DefineRegister returned: [lindex $msg 5]"
       } else {
           InsertLog "DefineRegister failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_inquire {} {
       variable RegName
       global errorCode errorInfo
       variable NetVarList 

       set z [catch {::namespace inscope ::urn:NetVarService InquireRegisters $RegName} msg]
       if {$z == 0} {
           InsertLog "InquireRegisters returned:"
           set NetVarList {*}
           foreach item [lindex $msg 5] {lappend NetVarList $item; InsertLog "$item"}
       } else {
           InsertLog "InquireRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_delete {} {
       variable RegName 
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:NetVarService DeleteRegisters $RegName} msg]

       if {$z == 0} {
           InsertLog "DeleteRegisters returned: [lindex $msg 5]"
       } else {
           InsertLog "DeleteRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_read {} {
       variable RegName
       global errorCode errorInfo
       variable RegData

       set z [catch {::namespace inscope ::urn:NetVarService ReadRegisters $RegName} msg]

       if {$z == 0} {
           InsertLog "ReadRegisters returned: [lindex $msg 5]"
           set RegData [second [first [lindex $msg 5]]]
       } else {
           InsertLog "ReadRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_write {} {
       variable RegName 
       variable RegData 
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:NetVarService WriteRegisters $RegName [list $RegData]} msg]

       if {$z == 0} {
           InsertLog "WriteRegisters returned: [lindex $msg 5]"
       } else {
           InsertLog "WriteRegisters failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_readattributes {} {
       variable RegName 
       global errorCode errorInfo
       variable RegN
       variable RegT
       variable RegP 
       variable RegF
       variable RegA 
       variable RegI
       variable RegL

       set z [catch {::namespace inscope ::urn:NetVarService ReadRegistersAttributes $RegName} msg]

       if {$z == 0} {
           InsertLog "ReadRegistersAttributes returned: [lindex $msg 5]"
           set attrlist [second [first [lindex $msg 5]]]
           foreach attr $attrlist {
               switch [string range $attr 1 1] {
                  n  {set RegN [string range $attr 2 end]}
                  t  {set RegT [string range $attr 2 end]}
                  f  {set RegF [string range $attr 2 end]}
                  a  {set RegA [string range $attr 2 end]}
                  p  {set RegP [string range $attr 2 end]}
                  i  {set RegI [string range $attr 2 end]}
                  l  {set RegL [string range $attr 2 end]}
                  default {}
               }
           }
       } else {
           InsertLog "ReadRegistersAttributes failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_writeattributes {} {
       variable RegName 
       variable RegN
       variable RegT
       variable RegP 
       variable RegF
       variable RegA 
       variable RegI
       variable RegL
       global errorCode errorInfo

       set z [catch {::namespace inscope ::urn:NetVarService \
            WriteRegistersAttributes $RegName "-n $RegN -t $RegT -p $RegP -f $RegF -a $RegA -l $RegL"} msg]

       if {$z == 0} {
           InsertLog "WriteRegistersAttributes returned: [lindex $msg 5]"
       } else {
           InsertLog "WriteRegistersAttributes failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }
   }

   proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable JS

       variable RegName 
       variable RegN
       variable RegT
       variable RegP 
       variable RegF
       variable RegA
       variable RegI
       variable RegL
       variable RegData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

            VERBOSE  {set Verbose [expr ($Verbose + 1) & 1]}

            CREATE   {do_create}
            DELETE   {do_delete}
            WRITEATTR  {do_writeattributes}
            READATTR   {do_readattributes}
            READ     {do_read}
            WRITE    {do_write}

            QUERY    {do_inquire}

            REGNAMES -
            REGNAME {set RegName [lindex $w 1]}

            REGN    {set RegN [lindex $w 1]}
            REGT    {set RegT [lindex $w 1]}
            REGP    {set RegP [lindex $w 1]}
            REGF    {set RegF [lindex $w 1]}
            REGA    {set RegA [lindex $w 1]}
            REGI    {set RegI [lindex $w 1]}
            REGL    {set RegL [lindex $w 1]}
            REGDATA {set RegData [lindex $w 1]}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
    }

}   ;# end of if {$started == 0}



